//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "DiskSector.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TForm1 *Form1;
unsigned char FD_Buf[TRACK_NUM*SECTOR_NUM*HEAD_NUM*BYTES_PRE_SECTOR];
int FD_Buf_Count;
Config cfg;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    Image1->Canvas->FloodFill(1,1,clWhite,fsBorder);
    Image2->Canvas->FloodFill(1,1,clWhite,fsBorder);
    Image3->Canvas->FloodFill(1,1,clWhite,fsBorder);
    cfg.Src = 'A';
    cfg.Dest = 'A';
    cfg.Verify = 1;
    cfg.Format = 1;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Label1MouseEnter(TObject *Sender)
{
    ((TLabel*)Sender)->Font->Color = (TColor)0xff0000;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Label1MouseLeave(TObject *Sender)
{
    ((TLabel*)Sender)->Font->Color = (TColor)0x00;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrawState(TImage *DrawTo, int Track, int Head, char *Str, TColor color, TColor TextColor)
{
    int BaseTop = 8, BaseLeft = 7;
    TRect tt;

    if( Track >= 40 )
        BaseTop = 56;

    tt.Left = BaseLeft + (Track%40)*13;
    tt.Right = tt.Left + 11;
    tt.Top = BaseTop + Head*18;
    tt.Bottom = tt.Top + 15;
    DrawTo->Canvas->Font->Color = TextColor;
    DrawTo->Canvas->Brush->Color = color;
    DrawTo->Canvas->Font->Size = 8;
    DrawTo->Canvas->TextRect(tt,tt.Left,tt.Top,(AnsiString)Str);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::QuickFill(TImage *FillTo, char *FillStr, TColor Color, TColor TextColor)
{
    for(int i=0; i<TRACK_NUM ; i++)
        for(int j=0; j<HEAD_NUM ; j++)
            DrawState(FillTo, i, j, FillStr, Color, TextColor);
    Application->ProcessMessages();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EnableAll(void)
{
    Read_Button->Enabled = true;
    Write_Button->Enabled = true;
    Verify_Dest_Btn->Enabled = true;
    Verify_Src_Btn->Enabled = true;
    Format_Button->Enabled = true;
    About_Button->Enabled = true;
    Dump_Button->Enabled = true;
    Get_Button->Enabled = true;
    Exit_Button->Enabled = true;
    Label1->Enabled = true;
    Label2->Enabled = true;
    Label3->Enabled = true;
    Label4->Enabled = true;
    Label5->Enabled = true;
    Label6->Enabled = true;
    Label7->Enabled = true;
    Label8->Enabled = true;
    Label9->Enabled = true;
    Label10->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DisableAll(void)
{
    Read_Button->Enabled = false;
    Write_Button->Enabled = false;
    Verify_Dest_Btn->Enabled = false;
    Verify_Src_Btn->Enabled = false;
    Format_Button->Enabled = false;
    About_Button->Enabled = false;
    Dump_Button->Enabled = false;
    Get_Button->Enabled = false;
    Exit_Button->Enabled = false;
    Label1->Enabled = false;
    Label2->Enabled = false;
    Label3->Enabled = false;
    Label4->Enabled = false;
    Label5->Enabled = false;
    Label6->Enabled = false;
    Label7->Enabled = false;
    Label8->Enabled = false;
    Label9->Enabled = false;
    Label10->Enabled = false;
}

//---------------------------------------------------------------------------
bool IsFloppy(char *drv)
{
    if(  GetDriveType(drv)== 2 )
        return true;
    return false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Read_ButtonClick(TObject *Sender)
{
    DisableAll();
    QuickFill(Image1 , " .", CLEAR_COLOR, BLACK_COLOR);
    QuickFill(Image2 , " ",  CLEAR_COLOR, BLACK_COLOR);

    int Index = 0;
    DiskSector *DiskIO = new DiskSector;
    DiskIO->Open(&cfg.Src);
    for(int i=0; i<TRACK_NUM ; i++)
        for(int j=0; j<HEAD_NUM ; j++ )
        {
            DrawState(Image1, i, j, "R", CLEAR_COLOR, FILL_COLOR);
            Image1->Refresh();
            DiskIO->ReadSector(Index, &FD_Buf[Index*BYTES_PRE_SECTOR], SECTOR_NUM);
            //DrawState(Image1, i, j, " ", FILL_COLOR);
            DrawState(Image2, i, j, " ", FILL_COLOR, FILL_COLOR);
            Image2->Refresh();
            //Application->ProcessMessages();
            Index += SECTOR_NUM;
        }
    DiskIO->Close();
    EnableAll();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Write_ButtonClick(TObject *Sender)
{
    DisableAll();
    QuickFill(Image3 , " .", CLEAR_COLOR, BLACK_COLOR);

    int Index = 0;
    DiskSector *DiskIO = new DiskSector;
    unsigned char VerifyBuf[SECTOR_NUM*BYTES_PRE_SECTOR];
    DiskIO->Open(&cfg.Dest);
    for(int i=0; i<TRACK_NUM ; i++)
        for(int j=0; j<HEAD_NUM ; j++ )
        {
            DrawState(Image3, i, j, "W", CLEAR_COLOR, FILL_COLOR);
            Image3->Refresh();
            DiskIO->WriteSector(Index, &FD_Buf[Index*BYTES_PRE_SECTOR], SECTOR_NUM);
            if( cfg.Verify )
            {
                DiskIO->ReadSector(Index, VerifyBuf, SECTOR_NUM);
                if( memcmp( &FD_Buf[Index*BYTES_PRE_SECTOR], VerifyBuf, SECTOR_NUM*BYTES_PRE_SECTOR ) )
                    DrawState(Image3, i, j, "X", CLEAR_COLOR, clRed);
                else
                    DrawState(Image3, i, j, "V", CLEAR_COLOR, FILL_COLOR);
            }

            Index += SECTOR_NUM;
        }
    DiskIO->Close();
    EnableAll();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Verify_Dest_BtnClick(TObject *Sender)
{
    DisableAll();
    QuickFill(Image3 , " .", CLEAR_COLOR, BLACK_COLOR);

    int Index = 0;
    DiskSector *DiskIO = new DiskSector;
    unsigned char CmpTmp[SECTOR_NUM*BYTES_PRE_SECTOR];
    DiskIO->Open(&cfg.Dest);
    for(int i=0; i<TRACK_NUM ; i++)
        for(int j=0; j<HEAD_NUM ; j++ )
        {
            DrawState(Image3, i, j, "V", CLEAR_COLOR, FILL_COLOR);
            Image3->Refresh();
            DiskIO->ReadSector(Index, CmpTmp, SECTOR_NUM);
            if( memcmp(&FD_Buf[Index*BYTES_PRE_SECTOR], CmpTmp,SECTOR_NUM*BYTES_PRE_SECTOR) )
                DrawState(Image3, i, j, "X", CLEAR_COLOR, clRed);
            Index += SECTOR_NUM;
        }
    DiskIO->Close();
    EnableAll();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Verify_Src_BtnClick(TObject *Sender)
{
    DisableAll();
    QuickFill(Image1 , " .", CLEAR_COLOR, BLACK_COLOR);

    int Index = 0;
    DiskSector *DiskIO = new DiskSector;
    unsigned char CmpTmp[SECTOR_NUM*BYTES_PRE_SECTOR];
    DiskIO->Open(&cfg.Src);
    for(int i=0; i<TRACK_NUM ; i++)
        for(int j=0; j<HEAD_NUM ; j++ )
        {
            DrawState(Image1, i, j, "V", CLEAR_COLOR, FILL_COLOR);
            Image1->Refresh();
            DiskIO->ReadSector(Index, CmpTmp, SECTOR_NUM);
            if( memcmp(&FD_Buf[Index*BYTES_PRE_SECTOR], CmpTmp,SECTOR_NUM*BYTES_PRE_SECTOR) )
            Index += SECTOR_NUM;
        }
    DiskIO->Close();
    EnableAll();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Dump_ButtonClick(TObject *Sender)
{
    DWORD   BufCnt;
    SaveDialog1->Execute();

    HANDLE hSaveFile = ::CreateFile(
    SaveDialog1->FileName.c_str(),
    GENERIC_READ | GENERIC_WRITE,
    0,
    NULL,
    CREATE_ALWAYS,
    0,
    NULL);

    if( hSaveFile != INVALID_HANDLE_VALUE)
    {
        //FileWrite((int)hSaveFile, FD_Buf, 80*18*2*512)
        WriteFile(hSaveFile, FD_Buf, TRACK_NUM*SECTOR_NUM*HEAD_NUM*BYTES_PRE_SECTOR, &BufCnt, NULL);
    }
    ::CloseHandle(hSaveFile);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Get_ButtonClick(TObject *Sender)
{
    DisableAll();
    DWORD   BufCnt;
    OpenDialog1->Execute();

    QuickFill(Image2 , " ", CLEAR_COLOR, CLEAR_COLOR);

    HANDLE hOpeneFile = ::CreateFile(
    OpenDialog1->FileName.c_str(),
    GENERIC_READ ,
    0,
    NULL,
    OPEN_EXISTING,
    0,
    NULL);

    if( hOpeneFile != INVALID_HANDLE_VALUE)
        if( ::ReadFile(hOpeneFile, FD_Buf, TRACK_NUM*SECTOR_NUM*HEAD_NUM*BYTES_PRE_SECTOR, &BufCnt, NULL) )
            if( BufCnt==(TRACK_NUM*SECTOR_NUM*HEAD_NUM*BYTES_PRE_SECTOR) )
            {
                for(unsigned int i=0; i<(BufCnt/SECTOR_NUM/HEAD_NUM/BYTES_PRE_SECTOR) ; i++)
                    for(unsigned int j=0; j<(BufCnt/TRACK_NUM/SECTOR_NUM/BYTES_PRE_SECTOR) ; j++)
                        DrawState(Image2, i, j, " ", FILL_COLOR, FILL_COLOR);
            }

    Application->ProcessMessages();
    ::CloseHandle(hOpeneFile);
    EnableAll();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Label1Click(TObject *Sender)
{
    TLabel *TmpLabel = ((TLabel *)Sender);
    char *OldDrv;
    char TmpBuf[3];

    if( TmpLabel == Label1 )
        OldDrv = &cfg.Src;
    else
        OldDrv = &cfg.Dest;

    if( *OldDrv== 'A' )
        strcpy(TmpBuf,"B:");
    else
        strcpy(TmpBuf,"A:");

    if( GetDriveType(TmpBuf)==2 )
    {
        *OldDrv = TmpBuf[0];
        AnsiString t = TmpLabel->Caption;
        TmpLabel->Caption = t.Delete(TmpLabel->Caption.Length(), 1);
        TmpLabel->Caption = TmpLabel->Caption + ((AnsiString) *OldDrv);
        if( TmpLabel == Label1 )
        {
            t.printf("Source  (%c:)", *OldDrv);
            GroupBox2->Caption = t;
        }
        else
        {
            t.printf("Destination  (%c:)", *OldDrv);
            GroupBox4->Caption = t;
        }
    }
    else
    {
        //Post error message
        return;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Label3Click(TObject *Sender)
{
    TLabel *TmpLabel = (TLabel *) Sender;
    unsigned char *TmpCfg;

    if( TmpLabel==Label3 )
        TmpCfg = &cfg.Verify;
    else if( TmpLabel==Label7 )
        TmpCfg = &cfg.HeadSettle;

    *TmpCfg = (*TmpCfg+1) % 2;
    if( TmpLabel )
    {
        AnsiString t = TmpLabel->Caption;
        TmpLabel->Caption = t.Delete(t.Length(), 1);
        if( *TmpCfg )
            TmpLabel->Caption = TmpLabel->Caption + "+";
        else
            TmpLabel->Caption = TmpLabel->Caption + "-";
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit_ButtonClick(TObject *Sender)
{
    if( ::MessageBox(Handle,"Do you want to exit ?","Exit",MB_YESNO)==IDYES )
        Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::About_ButtonClick(TObject *Sender)
{
    ::MessageBox(Handle,"FD-Copy Ver 0.1a\nThis is a freeware.\nCopyright (c) by   Jimmy Yin","About",MB_OK);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Format_ButtonClick(TObject *Sender)
{

    if( !cfg.Format )
        return;
    DisableAll();
    HANDLE hHeadFile = ::CreateFile(
    ".\\HeadFile",
    GENERIC_READ ,
    0,
    NULL,
    OPEN_EXISTING,
    0,
    NULL);

    if( hHeadFile != INVALID_HANDLE_VALUE)
    {
        unsigned int Index = 0;
        DiskSector *DiskIO = new DiskSector;
        DWORD   BufCnt;
        char *FarmatBuf = new char[TRACK_NUM*SECTOR_NUM*HEAD_NUM*BYTES_PRE_SECTOR];
        DiskIO->Open(&cfg.Dest);
        memset(FarmatBuf, 0, size_t TRACK_NUM*SECTOR_NUM*HEAD_NUM*BYTES_PRE_SECTOR);
        if( ::ReadFile(hHeadFile, FarmatBuf, TRACK_NUM*SECTOR_NUM*HEAD_NUM*BYTES_PRE_SECTOR, &BufCnt, NULL) )
        {
            unsigned char VerifyBuf[SECTOR_NUM*BYTES_PRE_SECTOR];
            QuickFill(Image3 , " .", CLEAR_COLOR, BLACK_COLOR);
            for(int i=0; i<TRACK_NUM ; i++)
                for(int j=0; j<HEAD_NUM ; j++ )
                {
                    DrawState(Image3, i, j, "F", CLEAR_COLOR, FILL_COLOR);
                    Image3->Refresh();
                    DiskIO->WriteSector(Index, &FarmatBuf[Index*BYTES_PRE_SECTOR], SECTOR_NUM);
                    if( cfg.Verify )
                    {
                        DiskIO->ReadSector(Index, VerifyBuf, SECTOR_NUM);
                        if( memcmp( &FarmatBuf[Index*BYTES_PRE_SECTOR], VerifyBuf, SECTOR_NUM*BYTES_PRE_SECTOR ) )
                            DrawState(Image3, i, j, "X", CLEAR_COLOR, clRed);
                        else
                            DrawState(Image3, i, j, "V", CLEAR_COLOR, FILL_COLOR);
                    }
                    if(  cfg.Format==1 && ((Index+SECTOR_NUM)*BYTES_PRE_SECTOR)>=BufCnt )
                        goto QuitFormat;
                    Index += SECTOR_NUM;
                }
            QuitFormat:;
        }
        DiskIO->Close();
    }
    else
        ::MessageBox(Handle,"Can't find Head-File .","Error !",MB_OK);

    ::CloseHandle(hHeadFile);
    EnableAll();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Label5Click(TObject *Sender)
{
    cfg.Format = (cfg.Format+1) % 3;

    AnsiString t = Label5->Caption;
    Label5->Caption = t.Delete(Label5->Caption.Length(), 1);
    if( cfg.Format==0 )
        Label5->Caption = Label5->Caption + ((AnsiString)"-");
    else if( cfg.Format==1 )
        Label5->Caption = Label5->Caption + ((AnsiString)"*");
    else
        Label5->Caption = Label5->Caption + ((AnsiString)"+");
}
//---------------------------------------------------------------------------



