//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>

#define FILL_COLOR  ((TColor)0x0011ff33)
#define CLEAR_COLOR ((TColor)0x00ffffff)
#define BLACK_COLOR ((TColor)0x00000000)
#define HEAD_NUM            (2)
#define SECTOR_NUM          (18)
#define TRACK_NUM           (80)
#define BYTES_PRE_SECTOR    (512)

typedef struct
{
    char Src;
    char Dest;
    unsigned char Verify;
    unsigned char FatSlt;
    unsigned char Format;
    unsigned char HeadSettle;
    unsigned char Verbose;
    unsigned char Expert;
    unsigned char Sound;
}Config;

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
    TGroupBox *GroupBox1;
    TButton *Read_Button;
    TButton *Write_Button;
    TButton *Verify_Dest_Btn;
    TButton *Verify_Src_Btn;
    TButton *Format_Button;
    TButton *About_Button;
    TButton *Dump_Button;
    TButton *Get_Button;
    TButton *Button11;
    TButton *Exit_Button;
    TLabel *Label1;
    TLabel *Label2;
    TLabel *Label3;
    TLabel *Label4;
    TLabel *Label5;
    TLabel *Label6;
    TLabel *Label7;
    TLabel *Label8;
    TLabel *Label9;
    TLabel *Label10;
    TLabel *Label11;
    TGroupBox *GroupBox2;
    TImage *Image1;
    TGroupBox *GroupBox3;
    TImage *Image2;
    TGroupBox *GroupBox4;
    TImage *Image3;
    TOpenDialog *OpenDialog1;
    TSaveDialog *SaveDialog1;
    TRichEdit *RichEdit1;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall Label1MouseEnter(TObject *Sender);
    void __fastcall Label1MouseLeave(TObject *Sender);
    void __fastcall Read_ButtonClick(TObject *Sender);
    void __fastcall Write_ButtonClick(TObject *Sender);
    void __fastcall Verify_Dest_BtnClick(TObject *Sender);
    void __fastcall Verify_Src_BtnClick(TObject *Sender);
    void __fastcall Dump_ButtonClick(TObject *Sender);
    void __fastcall Get_ButtonClick(TObject *Sender);
    void __fastcall Label1Click(TObject *Sender);
    void __fastcall Label3Click(TObject *Sender);
    void __fastcall Exit_ButtonClick(TObject *Sender);
    void __fastcall About_ButtonClick(TObject *Sender);
    void __fastcall Format_ButtonClick(TObject *Sender);
    void __fastcall Label5Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
    __fastcall TForm1(TComponent* Owner);
    void __fastcall DrawState(TImage *DrawTo, int Track, int Head, char *Str, TColor color, TColor TextColor);
    void __fastcall QuickFill(TImage *FillTo, char *FillStr, TColor Color, TColor TextColor);
    void __fastcall EnableAll(void);
    void __fastcall DisableAll(void);
    bool IsFloppy(char *drv);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
